<template>
    <div class="">
            <page-header title="Marques">

            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0">
                        <button @click="showModalOnCreate"  class="ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right"></i>  Nouvelle Marque
                        </button>
                    </h3>

                    <div class="card-tools d-flex">
                        <div class="btn-group btn-group-sm mr-2">
                            <button type="button" class="btn btn-secondary btn-xs btn-flat"><i class="fas fa-download right"></i> Télécharger</button>
                            <button type="button" class="btn btn-secondary btn-flat  dropdown-toggle dropdown-icon" data-toggle="dropdown" aria-expanded="false">
                            <span class="sr-only">Toggle Dropdown</span>
                            <div class="dropdown-menu" role="menu" x-placement="bottom-start" style="position: absolute; will-change: transform; top: 0px; left: 0px; transform: translate3d(-1px, 37px, 0px);">
                                <a class="dropdown-item" href="#"><i class="fa fa-file-pdf mr-2 "></i>PDF</a>
                                <a class="dropdown-item" href="#"><i class="fa fa-file-excel mr-2 "></i>Excel</a>
                            </div>
                            </button>
                        </div>
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable :css="table" ref="vuetable" api-url="api/marques" :fields="columns" 
                           pagination-path=""
                           :per-page="15"
                           @vuetable:loading="onLoading" 
                           :http-options="httpOptions"

                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           detail-row-component="mdetail-row-marques"
                           @vuetable:pagination-data="onPaginationData">
                          <template slot="modeles" slot-scope="props">   
                                <div class="custom-actions ">
                                      {{ props.rowData.modeles.length }}
                                    <button class="ml-2 btn btn-xs btn-default"
                                    @click="onCellClicked(props.rowData)">
                                    <i class="fas fa-caret-down" v-if="isDetailRowOpened(props.rowData.id)"></i>
                                    <i class="fas fa-caret-right" v-else></i>
                                      <span class="hidden-xs"></span>
                                    </button>
                                </div>
                            </template>
                            <template slot="actions" slot-scope="props">   
                            <div class="custom-actions">
                                <button class="btn btn-xs btn-secondary"
                                @click="showModalOnEdit(props.rowData)">
                                <i class="fas fa-edit"></i>
                                </button>
                                <button class="btn btn-xs btn-danger"
                                @click="remove(props.rowData.id)">
                                <i class="fas fa-trash"></i>
                                </button>
                            </div>
                            </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
              <b-modal @hidden="reset"  ref="inputModal" id="my-modal" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="onSubmit()"
                               @reset.prevent="reset()" 
                               @keydown="form.errors.clear($event.target.name)" 
                               @change="form.errors.clear($event.target.name)">
                        <div class="form-group ">
                            <label class="">Nom de la marque</label>
                            <input class="form-control form-control-sm " name="libelle" v-model="form.libelle" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('libelle')" v-text="form.errors.get('libelle')"></span>
                        </div>
                          <div class="form-group ">
                            <label class="">Pays d'origine</label>
                            <select class="form-control form-control-sm " name="libelle" v-model="form.pays_id" type="text">
                              <option value="">Choix du pays d'origine</option>
                               <option v-for="(country,index) in options.pays" :key="index" :value="country.id" v-text="country.libelle"></option>
                            </select> 
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('pays_id')" v-text="form.errors.get('pays_id')"></span>
                        </div>

                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button type="submit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
											</div>
               </form>
            </b-modal>
            <!-- Modal fin -->
</div>
    </div>
</template>

<script>
 
   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";


   

    export default {
        mixins: [Master],
        data(){
            return{
                modeEdit:false,
                ftime:true,
                hasData:false,
                options :
                {
                   pays: []
                },
                url:"api/marques",
                deleteConfirme:{
                  message:"Voulez-vous supprimer cette marque ?",
                  title:"Suppréssion d'une marque"
                },
                form : new Form({
                    libelle:"",
                    pays_id:''
                }),
                moreParams:{},
                isLoading:false,
                columns : [
                {
                    name: 'libelle',
                    title: "Libellé"
                },
                {
                    name: 'pays_id',
                    title: "Pays d'origine",
                    callback: 'getRelation'
                },
                
                {
                name: '__slot:modeles',   // <----
                title: 'Nombre de modeles',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },
                {
                    name: 'created_at',
                    title: "Date d'enregistrement",
                    callback: 'formatDate|D-MM-Y à H:mm'
                },
                {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
          this.modeEdit = false
          axios.get("api/pays").then((response) => 
          { 
                 this.options.pays = response.data
          },
          (error) =>
          {
            this.isLoading = false
          });
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une  marque"  : " Ajout d'une marque"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            }
        },
        methods: 
        {
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            onAction (action, data, index) {
            console.log('slot) action: ' + action, data, index)
            },
            onFilterSet (filterText) {
                this.moreParams = {
                    'filter': filterText
                }
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams = {}
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire une marque de la BDD
             remove(e)
             { 
              //On demande la confirmation de la suppression
                alertConfirm(this.deleteConfirme.message,this.deleteConfirme.title)
                .then(result => {
                    //On réinitialise le chargement
                    this.isLoading = true
                    if(result)
                    {
                        axios.delete(this.url+"/"+e).then((response) => 
                        { 
                          // on rafraichit la page de donnée actuelle
                          !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                          //on notifie l'effectivité de la suppréssion
                          flash('Suppresion réussie')
                          //On réinitialise le chargement
                          this.isLoading = false

                        },
                        (error) =>
                        {
                          this.isLoading = false
                        });
                    }
                })
                .catch(error => {
                    reject(error);
                });
             },
             //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute une marque dans la BDD
            add()
            {
                //Requête ajax
                this.form.post(this.url).then((value) => 
                {  
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")

                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            },
            //Actualise  un marque dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch(this.url+"/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Ajout <strong>impossible</strong></span>","danger")
                });                  
            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()
              
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {
               
                this.reset()
                this.modeEdit = true
                this.form.libelle = entity.libelle
                this.form.id=entity.id
                this.form.pays_id=entity.pays_id
                this.$refs['inputModal'].show()
             },
              //Initialisation du formulaire
              reset()
             {
                  this.form.reset();
                  this.$refs['inputModal'].hide()
                  this.modeEdit = false
                  this.isLoading = false
                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
             getRelation(value)
             {
               var elem = this.$refs.vuetable.tableData.find( e => e.pays_id == value);
               if(elem.pays!=null)
                 return elem.pays.libelle
               else
                 return "-"
             },
              onCellClicked (data,event) {
                 console.log('cellClicked: ')
                this.$refs.vuetable.toggleDetailRow(data.id)
              },
             //Verifie si un detail row est ouvert ou fermé
              isDetailRowOpened(id)
              {
                return  this.$refs.vuetable.visibleDetailRows.includes(id)
              }, 
              
        },
        components:
        {

            Vuetable,
            pa
        }
    }
</script>